
open "pack";

val fsig = { "O" => ("nat", nil),
	     "S" => ("nat", ["nat"]),
	     "nil" => ("nat list", nil),
	     "cons" => ("nat list", ["nat", "nat list"])
		   (*
	     "+" => ("nat", ["nat", "nat"]),
	     "*" => ("nat", ["nat", "nat"])
		    *)
	     };

val Z = "O" $ nil;
fun S x = "S" $ [x];

val predsig = { "Plus" => ["nat", "nat", "nat"],
		"Mul" => ["nat", "nat", "nat"],
		"P" => ["nat", "nat", "nat"],
		"Q" => ["nat", "nat", "nat"],
		"signal" => [],
		"Less" => ["nat", "nat"]
		};

fun Plus (s, t) = ATOM ("Plus", [s, t]);
fun Mul (s, t) = ATOM ("Mul", [s, t]);
val m = V "m"
val n = V "n"
val p = V "p"
val t = V "t"
val x = V "x"
val y = V "y"
fun P (t, x, y) = ATOM ("P", [t, x, y]);
fun Q (t, x, y) = ATOM ("Q", [t, x, y]);
fun Less (s, t) = ATOM ("Less", [s, t]);

val time_limit = S (S (S Z));

val prog = PROG (predsig,
		 { (*
		    "Plus" => [ DCLAUSE ("Plus-0",
		    { "m" => "nat" },
		    Plus (m, Z, m),
		    nil),
		    DCLAUSE ("Plus-S",
		    { "m" => "nat", "n" => "nat", "p" => "nat" },
		    Plus (m, S n, S p),
		    [Plus (m, n, p)])
		    ]
		    ,
		    "Mul" => [ DCLAUSE ("Mul-0",
		    { "m" => "nat" },
		    Mul (m, Z, Z),
		    nil),
		    DCLAUSE ("Mul-S",
		    { "m" => "nat", "n" => "nat",
		    "p" => "nat", "q" => "nat" },
		    Mul (m, S n, p),
		    [ Mul (m, n, q),
		    Plus (q, n, p)])
		    ]
		    ,
		    *)
		   "Less" => [ DCLAUSE ("0<Sn",
					{ "n" => "nat" },
					  Less (Z, S n),
					  nil),
			       DCLAUSE ("Sm<Sn",
					{ "m" => "nat", "n" => "nat" },
					  Less (S m, S n),
					  [ Less (m, n) ])
			       ],		   "P" => [ DCLAUSE ("P-advance-time",
				     { "t" => "nat", "x" => "nat", "y" => "nat" },
				       P (S t, S x, S y),
				       [ P (t, x, y)]),
			    DCLAUSE ("P-reset-y",
				     { "t" => "nat", "x" => "nat", "y" => "nat" },
				       P (t, x, Z),
				       [ P (t, x, time_limit)]),
			    DCLAUSE ("P-init",
				     {},
				       P (Z, Z, Z),
				       nil)
			    ],
		   "Q" => [ DCLAUSE ("Q-from-P",
				     { "t" => "nat", "x" => "nat", "y" => "nat" },
				       Q (t, x, y),
				       [ P (t, x, y),
					 Less (x, time_limit)])
			    ],
		   "signal" => [ DCLAUSE ("signal",
					  { "t" => "nat", "x" => "nat", "y" => "nat" },
					    ATOM ("signal", nil),
					    [ Q (t, x, y),
					      Less (time_limit, y)])
				 ]
		   }
		   );

(*				     
engine (fsig, prog, ["signal"], [], order_of_prec [], true);
engine (fsig, prog, ["signal"], [T_INLINE "^Less"], order_of_prec [], true);
engine (fsig, prog, ["signal"], [T_INLINE "^Less", T_MAGIC], order_of_prec [], true);
*)
val tab = engine (fsig, prog, ["signal"], [T_INLINE "^Less", T_MAGIC, T_PARTITION ("^P", "^nat")], order_of_prec [], true);
print_tableau ({f => len sl | f => (_, sl) in map fsig}, stderr) tab;
#flush stderr ();
