
open "magic_h"

val magic_count = ref 0

fun magic_name P =
    let val f as |[put, convert, ...]| = outstring P
    in
	put "-magic:";
	print f (pack (!magic_count));
	convert ()
    end;

fun magic psig =
    fn P =>
       let val P' = magic_name P
	   val ps = !psig
       in
	   (psig := ps ++ {P' => ?ps P}; P')
	   handle MapGet => raise NoPredSig P
       end;

fun magic_atom psig =
    let val mag = magic psig
    in
	fn (ATOM (P, l)) => ATOM (mag P, l)
    end;

fun magic_up psig =
    let val mag = magic psig
	val maga = magic_atom psig
    in
	fn (P, dcls) =>
	   [DCLAUSE (magic_name name ^ "-up", env, h,
		     maga h :: body)
	   | DCLAUSE (name, env, h, body) in list dcls]
    end;

fun magic_down_name (name, i : int) =
    let val f as |[put, convert, ...]| = outstring name
    in
	put "-magic";
	print f (pack (!magic_count));
	put "-down";
	print f (pack i);
	convert ()
    end;

fun magic_templates (PROG (predsig, pr), goals) =
    let val downs = ref {}
	val psig = ref predsig
	val mag = magic psig
	val maga = magic_atom psig
	val magup = magic_up psig
	fun add dcl = downs := add_gclause (!downs, dcl)
	val up = {P => (iterate
			  let val ir = ref 0
			      val magic_head = maga h
			      val bodies = ref nil
			  in
			      iterate
				(inc ir;
				 add (DCLAUSE (magic_down_name (name, !ir),
					       env,
					       maga a,
					       magic_head :: !bodies));
				 bodies := a :: !bodies)
			      | a in list body
			      end
			  end
			| DCLAUSE (name, env, h, body) in list dcls
			end;
			  magup (P, dcls))
		 | P => dcls in map pr}
    in
	inc magic_count;
	iterate
	  add (DCLAUSE (magic_name ("goal-" ^ signal), {},
			ATOM (mag signal, nil), nil))
	| signal in list goals
	end;
	PROG (!psig, up ++ !downs)
    end;
