
(*
 *	Copyright (c) 2002 by Laboratoire Spcification et Vrification (LSV),
 *	CNRS UMR 8643 & ENS Cachan.
 *	Written by Jean Goubault-Larrecq.  Not derived from licensed software.
 *
 *	Permission is granted to anyone to use this software for any
 *	purpose on any computer system, and to redistribute it freely,
 *	subject to the following restrictions:
 *
 *	1. Neither the author nor its employer is responsible for the consequences of use of
 *		this software, no matter how awful, even if they arise
 *		from defects in it.
 *
 *	2. The origin of this software must not be misrepresented, either
 *		by explicit claim or by omission.
 *
 *	3. Altered versions must be plainly marked as such, and must not
 *		be misrepresented as being the original software.
 *
 *	4. This software is restricted to non-commercial use only.  Commercial
 *		use is subject to a specific license, obtainable from LSV.
 *		This was developed as part of the EVA project; as such, access
 *		to this software by partners of the RNTL EVA Project (Trusted
 *		Logic S.A., Verimag) is defined by the intellectual property
 *		agreement signed as part of this project.
 *)

open "lisptoken_h"
open "lispin_h"

fun yyerr (yyd, exc) = (hlex_begin (yyd, 0);
                        hlex_flush (yyd, hlex_current_buffer yyd);
                        raise exc);

fun read_octal (s, i) =
    let val n = size s
	val ir = ref i
        val acc = ref 0
    in
       while !ir<n do
         (acc := lsl (!acc, 3) + ordof (s, !ir)-48;
          inc ir);
       !acc
    end;

fun read_dec (s, i) =
    let val n = size s
	val ir = ref i
        val acc = ref 0
    in
       while !ir<n do
         (acc := !acc*10 + ordof (s, !ir)-48;
          inc ir);
       !acc
    end;


local
		val return = SOME;
		val continue = NONE;
		val yyterminate = (fn _ => SOME 0 (* end of file reached *));
		infix 0 hlex_then;
		fun f hlex_then g = fn yyd => (f yyd; g yyd);
		val INITIAL = 0;
		val STRING = 1;

		val yy_end_of_buffer=20;
		val action_0 = fn _ => continue;
val yy_accept = (* 32 entries *) 
    [   0,
        0,    0,    0,    0,   20,    5,    1,    6,    2,    3,
        4,   17,    8,    7,   18,    5,    1,    4,   17,    8,
       16,    9,   14,   15,   11,   13,   12,    9,    9,   10,
        0
    ];

val yy_ec = (* 256 entries *) 
    [   0,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
        1,    1,    2,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    2,    1,    4,    1,    1,    1,    1,    1,    5,
        6,    1,    1,    1,    1,    1,    1,    7,    7,    7,
        7,    7,    7,    7,    7,    8,    8,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    9,    1,    1,    1,    1,    1,   10,    1,    1,

        1,   11,    1,    1,    1,    1,    1,    1,    1,   12,
        1,    1,    1,   13,    1,   14,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1
    ];

val yy_meta = (* 15 entries *) 
    [   0,
        1,    2,    3,    3,    2,    2,    1,    1,    4,    1,
        1,    1,    1,    1
    ];

val yy_base = (* 35 entries *) 
    [   0,
        0,    0,   12,   19,   54,    0,   15,   55,   55,   55,
       12,    0,   50,   55,   28,    0,   22,    0,    0,   46,
       55,   41,   55,   55,   55,   55,   55,   24,   20,   19,
       55,   42,   46,   50
    ];

val yy_def = (* 35 entries *) 
    [   0,
       31,    1,   32,   32,   31,   33,   31,   31,   31,   31,
       33,   34,   31,   31,   31,   33,   31,   11,   34,   31,
       31,   31,   31,   31,   31,   31,   31,   31,   31,   31,
        0,   31,   31,   31
    ];

val yy_nxt = (* 70 entries *) 
    [   0,
        6,    7,    7,    8,    9,   10,   11,   11,    6,    6,
        6,    6,    6,    6,   13,   14,   17,   17,   18,   18,
       15,   13,   14,   17,   17,   30,   30,   15,   21,   21,
       29,   21,   21,   21,   22,   21,   21,   23,   24,   25,
       26,   27,   12,   12,   12,   12,   16,   28,   20,   16,
       19,   19,   20,   31,    5,   31,   31,   31,   31,   31,
       31,   31,   31,   31,   31,   31,   31,   31,   31
    ];

val yy_chk = (* 70 entries *) 
    [   0,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    3,    3,    7,    7,   11,   11,
        3,    4,    4,   17,   17,   30,   29,    4,   15,   15,
       28,   15,   15,   15,   15,   15,   15,   15,   15,   15,
       15,   15,   32,   32,   32,   32,   33,   22,   20,   33,
       34,   34,   13,    5,   31,   31,   31,   31,   31,   31,
       31,   31,   31,   31,   31,   31,   31,   31,   31
    ];

val yy_NUL_trans = nil;


	val string_buf = outstring "";


val action_1 = (fn yyd => (
continue
	));
val action_2 = (fn yyd => (
return LISP_LPAREN
	));
val action_3 = (fn yyd => (
return LISP_RPAREN
	));
val action_4 = (fn yyd => (
return (LISP_INT (read_dec (hlex_text yyd, 0)))
	));
val action_5 = (fn yyd => (
return (LISP_ID (hlex_text yyd))
	));
val action_6 = (fn yyd => (
#seek string_buf 0; #truncate string_buf (); hlex_begin (yyd, STRING); continue
	));
val action_21 = (fn yyd => (
yyerr (yyd, LispEof)
	));


val action_7 = (fn yyd => (
hlex_begin (yyd, INITIAL); return (LISP_STRING (#convert string_buf ()))
	));
val action_8 = (fn yyd => (
continue
	));
val action_9 = (fn yyd => (
#put string_buf (chr (read_octal (hlex_text yyd, 1))); continue
	));
val action_10 = (fn yyd => (
yyerr (yyd, LispBadEscape (hlex_text yyd))
	));
val action_11 = (fn yyd => (
#put string_buf "\n"; continue
	));
val action_12 = (fn yyd => (
#put string_buf "\t"; continue
	));
val action_13 = (fn yyd => (
#put string_buf "\^M"; continue
	));
val action_14 = (fn yyd => (
#put string_buf "\^G"; continue
	));
val action_15 = (fn yyd => (
#put string_buf "\f"; continue
	));
val action_16 = (fn yyd => (
#put string_buf (chr (ordof (hlex_text yyd, 1))); continue
	));
val action_17 = (fn yyd => (
#put string_buf (hlex_text yyd); continue
	));
val action_22 = (fn yyd => (
yyerr (yyd, LispEofInString)
	));
val action_18 = (fn yyd => (
#put string_buf (hlex_text yyd); continue
	));

val action_19 = (fn yyd => (
raise Hlex 8 (* hlex scanner jammed *)
	));
val action = [ action_0,
               action_1,
               action_2,
               action_3,
               action_4,
               action_5,
               action_6,
               action_7,
               action_8,
               action_9,
               action_10,
               action_11,
               action_12,
               action_13,
               action_14,
               action_15,
               action_16,
               action_17,
               action_18,
               action_19,
               action_0,
               action_21,
               action_22]
val yytables =
  hlex_tables (action, 19, yy_end_of_buffer, yy_accept, yy_ec, yy_meta, yy_base, yy_def, yy_nxt, yy_chk, yy_NUL_trans, 55, 31, 1)
in
  val yylex = hlex yytables
end;


exception LispNoFunction
exception LispUnexpectedFunction of string
exception LispRParenEvt
exception LispExpectedInt
exception LispExpectedFile
exception LispExpectedRParen

fun lispread1 yyd =
    (case yylex yyd of
	 LISP_LPAREN => (case yylex yyd of
			     LISP_ID "line" =>
			     let val t = lispread1 yyd
				 val m = lispreadint yyd
				 val n = lispreadint yyd
				 val p = lispreadint yyd
				 val q = lispreadint yyd
				 val s = lispreadstring yyd
			     in
				case yylex yyd of
				    LISP_RPAREN =>
				    LINE (t, |[ first_line = m,
						first_column = n,
						last_line = p,
						last_column = q,
						in_file = s
						]|)
				  | _ => raise LispExpectedRParen
			     end
			   | LISP_ID fname => APP (fname, lispreadlist yyd)
			   | _ => raise LispNoFunction)
       | LISP_RPAREN => raise LispRParenEvt
       | LISP_INT n => INT n
       | LISP_STRING s => VAR s
       | LISP_ID s => raise (LispUnexpectedFunction s))
and lispreadlist yyd =
    (lispread1 yyd::lispreadlist yyd handle LispRParenEvt => nil)
and lispreadint yyd =
    (case lispread1 yyd of
	 INT n => n
       | _ => raise LispExpectedInt)
and lispreadstring yyd =
    (case lispread1 yyd of
	 VAR s => s
       | APP ("nil", []) => ""
       | _ => raise LispExpectedFile);

fun lispread f =
    let val yyd = hlex_data (f, fn _ => true)
    in
	lispread1 yyd
    end;

fun lispwrite (f as |[put, ...]|) =
    let fun outint i = print f (pack (i:int))
	fun outintsp i = (put " "; outint i)
	fun outescape s =
	    iterate
	      if i=34
		  then put "\\\""
	      else if i<32 orelse i>=128 andalso i<160
		  then let val (a, i3) = i divmod 8
			   val (i1, i2) = a divmod 8
		       in
			   put "\\";
			   put (chr (i1+48));
			   put (chr (i2+48));
			   put (chr (i3+48))
		       end
	      else put c
	    | c in list explode s
	    val i = ord c
	    end
	val margin = ref 0
	fun cr () = let val i = ref (!margin)
		    in
			put "\n";
			while (!i<>0) do
			    (dec i;
			     put " ")
		    end
	fun write (VAR s) = (put "\""; outescape s; put "\"")
	  | write (INT i) = outint i
	  | write (APP (f, l)) = (put "("; put f; wl l; put ")")
	  | write (LINE (t, |[ first_line, first_column, last_line, last_column, in_file ]|)) =
	    (put "(line "; write t;
	     outintsp first_line; outintsp first_column; outintsp last_line; outintsp last_column;
	     put " \""; outescape in_file; put "\")")
        and wl l = (margin := !margin + 2;
		    iterate
		      (cr (); write t)
		    | t in list l
		    end;
		    margin := !margin - 2)
    in
	fn t => (margin := 0; write t)
    end;

